use std::fs::File;
use std::io::{Read, Write};
use std::env;
use std::path::Path;

const BUFFER_SIZE: usize = 16;

fn main() {    
    let args: Vec<_> = env::args().collect();
    if args.len() != 3 {
        println!("Not enough arguments - exiting.");
        return
    }
    println!("Buffer size: {}.", BUFFER_SIZE);

    let input = std::env::args().nth(1).unwrap();
    let b = Path::new(&input).exists();
    if b == false {
        println!("The {} path does not exist!", input);
        return
    }

    let output = std::env::args().nth(2).unwrap();
    let c = Path::new(&output).exists();
    if c == true {
        println!("The {} path already exists!", output);
        return
    }

    let mut input_file= File::open(input).unwrap();
    let mut buf=[0u8;BUFFER_SIZE];
    let mut buffer = File::create(output).unwrap();
    let mut cont: bool = true;

    while cont {
        let read_bytes = input_file.read(&mut buf).unwrap();
        if read_bytes!=buf.len() {
            cont=false
        }

        let _i = buffer.write_all(buf.as_ref()); 
        match _i {
            Ok(()) => {
                print!(".");
            },
            Err(_e) => {
                println!("{}:", _e);
            }
        }
        buffer.flush().unwrap();
    }
    println!();
}
