use std::fs::File;
use std::io::Read;
use std::env;
use std::path::Path;

const BUFFER_SIZE: usize = 16;

fn main() {    
    let args: Vec<_> = env::args().collect();
    if args.len() != 2 {
        println!("Need a file to read.");
        return
    }

    let input = std::env::args().nth(1).unwrap();
    let b = Path::new(&input).exists();
    if b == false {
        println!("The {} path does not exist!", input);
        return
    }

    let mut input_file = File::open(input).unwrap();
    let mut buf = [0u8;BUFFER_SIZE];
    let mut cont: bool = true;

    while cont {
        let read_bytes = input_file.read(&mut buf).unwrap();
        if read_bytes != buf.len() {
            cont = false
        }
        print!("{}", std::str::from_utf8(&buf[0..read_bytes]).unwrap());
    }
}
