fn main() {
    let mut a_vector = Vec::new();
    a_vector.push(2);
    a_vector.push(-2);
    a_vector.push(12);

    println!("a_vector is: {:?}", a_vector);

    // Vectors can be accessed as arrays:
    println!("The first element of a_vector is {}", a_vector[0]);
    
    // Length and capacity
    println!("Length {} + capacity: {}", a_vector.len(), a_vector.capacity());
    a_vector.push(25);
    a_vector.push(20);
    println!("Length {} + capacity: {}", a_vector.len(), a_vector.capacity());
    println!("Select 2 elements: {:?}", &a_vector[0..2]);

    // Doing something with all Vector elements
    for x in a_vector.iter() {
            print!("{} ", x);
    }
    println!();

    for i in 0..a_vector.len() {
            print!("{} ", a_vector[i]);
    }
    println!();

    for i in &a_vector {
        print!("{} ", i);
    }
    println!();

    // This will crash the program!
    // println!("{}", a_vector[5]);

    // This will not crash it!
    match a_vector.get(5) {
        Some(x) => println!("The value of a_vector[5] is: {}", x),
        None => println!("a_vector[5] is not defined!")
    }

    for _ in 0..a_vector.len() {
        match a_vector.pop() {
            Some(x) => print!("x is {:?} ", x),
            None => println!("It is not defined!")
        }
    }
    println!();

    // This is not robust
    let an_element = a_vector.pop();
    println!("an_element is {:?}", an_element);

    // This is more robust
    match a_vector.pop() {
        Some(x) => println!("x is {:?}", x),
        None => println!("Pop(): it is not defined!")
    }

}
